diff -r -c bash-1_14_7/lib/readline/readline.c bash1147/lib/readline/readline.c
*** bash-1_14_7/lib/readline/readline.c	Wed Mar 10 09:44:02 1999
--- bash1147/lib/readline/readline.c	Fri Mar 19 15:40:04 1999
***************
*** 67,73 ****
--- 67,75 ----
     to be visible to readline callers. */
  
  /* Functions imported from other files in the library. */
+ #ifndef VMS
  extern char *tgetstr ();
+ #endif
  extern void rl_prep_terminal (), rl_deprep_terminal ();
  
  extern void _rl_bind_if_unbound ();
***************
*** 102,108 ****
--- 104,114 ----
  
  int _rl_dispatch ();
  void _rl_set_screen_size ();
+ #ifdef _BSD44_CURSES
+ void _rl_output_character_function ();
+ #else
  int _rl_output_character_function ();
+ #endif
  
  static char *readline_internal ();
  static void readline_initialize_everything ();
***************
*** 526,531 ****
--- 532,538 ----
    result = ioctl (tty, FIONREAD, &chars_avail);
  #endif
  
+ #ifndef VMS
  #if defined (O_NDELAY)
    if (result == -1)
      {
***************
*** 541,546 ****
--- 548,554 ----
  	return;
      }
  #endif /* O_NDELAY */
+ #endif
  
    /* If there's nothing available, don't waste time trying to read
       something. */
***************
*** 982,991 ****
    /* Initialize the terminal interface. */
    init_terminal_io ((char *)NULL);
  
! #if !defined (__GO32__)
    /* Bind tty characters to readline functions. */
    readline_default_bindings ();
  #endif /* !__GO32__ */
  
    /* Initialize the function names. */
    rl_initialize_funmap ();
--- 990,1002 ----
    /* Initialize the terminal interface. */
    init_terminal_io ((char *)NULL);
  
! #if !defined (__GO32__) && !defined (_BSD44_CURSES)
    /* Bind tty characters to readline functions. */
    readline_default_bindings ();
  #endif /* !__GO32__ */
+ #ifdef _BSD44_CURSES
+   initscr ();
+ #endif
  
    /* Initialize the function names. */
    rl_initialize_funmap ();
***************
*** 1027,1037 ****
--- 1038,1050 ----
  /* If this system allows us to look at the values of the regular
     input editing characters, then bind them to their readline
     equivalents, iff the characters are not bound to keymaps. */
+ #if !defined(_BSD44_CURSES)
  static void
  readline_default_bindings ()
  {
    rltty_set_default_bindings (_rl_keymap);
  }
+ #endif
  
  static void
  bind_arrow_keys_internal ()
***************
*** 1373,1378 ****
--- 1386,1394 ----
  #else /* !__GO32__ */
  
    char *term, *buffer;
+ #ifdef VMS
+   char *termcap;
+ #endif
    int tty;
    Keymap xkeymap;
  
***************
*** 1486,1498 ****
  }
  
  /* A function for the use of tputs () */
! int
  _rl_output_character_function (c)
       int c;
  {
    return putc (c, out_stream);
  }
! 
  /* Write COUNT characters from STRING to the output stream. */
  void
  _rl_output_some_chars (string, count)
--- 1502,1520 ----
  }
  
  /* A function for the use of tputs () */
! #ifdef _BSD44_CURSES
! void
  _rl_output_character_function (c)
+ {
+   putc (c, out_stream);
+ }
+ #else
+ int _rl_output_character_function (c)
       int c;
  {
    return putc (c, out_stream);
  }
! #endif
  /* Write COUNT characters from STRING to the output stream. */
  void
  _rl_output_some_chars (string, count)
***************
*** 3302,3307 ****
--- 3324,3333 ----
    if (isatty (0))
      return (getkey () & 0x7F);
  #endif /* __GO32__ */
+ #ifdef _BSD44_CURSES
+   if (isatty (0))
+     return getch ();
+ #endif
  
    while (1)
      {
***************
*** 3315,3320 ****
--- 3341,3347 ----
        if (result == 0)
  	return (EOF);
  
+ #ifndef VMS
  #if defined (EWOULDBLOCK)
        if (errno == EWOULDBLOCK)
  	{
***************
*** 3347,3352 ****
--- 3374,3380 ----
  	    }
  	}
  #endif /* _POSIX_VERSION && EAGAIN && O_NONBLOCK */
+ #endif
  
  #if !defined (__GO32__)
        /* If the error that we received was SIGINT, then try again,
diff -r -c bash-1_14_7/lib/readline/rldefs.h bash1147/lib/readline/rldefs.h
*** bash-1_14_7/lib/readline/rldefs.h	Wed Mar 10 09:44:02 1999
--- bash1147/lib/readline/rldefs.h	Wed Mar 10 09:45:19 1999
***************
*** 47,52 ****
--- 47,58 ----
  #  undef HAVE_BSD_SIGNALS
  #endif
  
+ #ifdef VMS
+ #undef NEW_TTY_DRIVER
+ #define _BSD44_CURSES 1
+ #include <curses.h>
+ #endif
+ 
  /* System V machines use termio. */
  #if !defined (_POSIX_VERSION)
  #  if defined (USG) || defined (hpux) || defined (Xenix) || defined (sgi) || \
***************
*** 87,92 ****
--- 93,102 ----
  #  include <sgtty.h>
  #endif
  
+ #if 1
+ #  define D_NAMLEN(d) strlen ((d)->d_name)
+ #else
+ 
  #if !defined (SHELL) && (defined (_POSIX_VERSION) || defined (USGr3))
  #  if !defined (HAVE_DIRENT_H)
  #    define HAVE_DIRENT_H
***************
*** 111,116 ****
--- 121,127 ----
  #    define dirent direct
  #  endif /* !dirent */
  #endif /* !HAVE_DIRENT_H */
+ #endif
  
  #if defined (USG) && defined (TIOCGWINSZ) && !defined (Linux)
  #  if defined (HAVE_SYS_STREAM_H)
diff -r -c bash-1_14_7/lib/readline/rltty.c bash1147/lib/readline/rltty.c
*** bash-1_14_7/lib/readline/rltty.c	Wed Mar 10 09:44:02 1999
--- bash1147/lib/readline/rltty.c	Fri Mar 19 15:40:32 1999
***************
*** 126,137 ****
--- 126,146 ----
  extern char *term_ks;
  extern char *term_ke;
  
+ #ifdef _BSD44_CURSES
+ static void
+ outchar (c)
+      int c;
+ {
+   putc (c, rl_outstream);
+ }
+ #else
  static int
  outchar (c)
       int c;
  {
    return putc (c, rl_outstream);
  }
+ #endif
  
  /* Turn on/off the meta key depending on ON. */
  static void
***************
*** 347,352 ****
--- 356,362 ----
  }
  
  #else  /* !defined (NEW_TTY_DRIVER) */
+ #ifndef _BSD44_CURSES
  
  #if !defined (VMIN)
  #  define VMIN VEOF
***************
*** 495,500 ****
--- 505,511 ----
  
  #endif /* TERMIOS_TTY_DRIVER && _POSIX_VDISABLE */
  }
+ #endif /* _BSD44_CURSES */
  #endif  /* NEW_TTY_DRIVER */
  
  /* Put the terminal in CBREAK mode so that we can detect key presses. */
***************
*** 504,510 ****
  {
  #if !defined (__GO32__)
    int tty = fileno (rl_instream);
!   TIOTYPE tio;
  
    if (terminal_prepped)
      return;
--- 515,523 ----
  {
  #if !defined (__GO32__)
    int tty = fileno (rl_instream);
! #ifndef _BSD44_CURSES
!     TIOTYPE tio;
! #endif
  
    if (terminal_prepped)
      return;
***************
*** 512,517 ****
--- 525,536 ----
    /* Try to keep this function from being INTerrupted. */
    block_sigint ();
  
+ #ifdef _BSD44_CURSES
+   crmode ();
+   noecho ();
+   nodelay (stdscr, 0);
+ #else
+ 
    if (get_tty_settings (tty, &tio) < 0)
      {
        release_sigint ();
***************
*** 527,532 ****
--- 546,552 ----
        release_sigint ();
        return;
      }
+ #endif
  
    control_meta_key (1);
  #if 0
***************
*** 552,557 ****
--- 572,581 ----
    /* Try to keep this function from being INTerrupted. */
    block_sigint ();
  
+ #ifdef _BSD44_CURSES
+   nocrmode ();
+   echo ();
+ #else
    control_meta_key (0);
  #if 0
    control_keypad (0);
***************
*** 563,569 ****
        release_sigint ();
        return;
      }
! 
    terminal_prepped = 0;
  
    release_sigint ();
--- 587,593 ----
        release_sigint ();
        return;
      }
! #endif
    terminal_prepped = 0;
  
    release_sigint ();
***************
*** 640,645 ****
--- 664,670 ----
  /*			Default Key Bindings			    */
  /*								    */
  /* **************************************************************** */
+ #if !defined(_BSD44_CURSES)
  void
  rltty_set_default_bindings (kmap)
       Keymap kmap;
***************
*** 703,705 ****
--- 728,731 ----
      }
  #endif /* !NEW_TTY_DRIVER */
  }
+ #endif
diff -r -c bash-1_14_7/lib/readline/tilde.c bash1147/lib/readline/tilde.c
*** bash-1_14_7/lib/readline/tilde.c	Wed Mar 10 09:44:03 1999
--- bash1147/lib/readline/tilde.c	Fri Mar 19 15:24:08 1999
***************
*** 292,298 ****
--- 292,300 ----
  	      free (dirname);
  	      dirname = temp_name;
  	    }
+ #ifndef VMS
  	  endpwent ();
+ #endif
  	  free (username);
  	}
      }
diff -r -c bash-1_14_7/lib/readline/vi_mode.c bash1147/lib/readline/vi_mode.c
*** bash-1_14_7/lib/readline/vi_mode.c	Wed Mar 10 09:44:03 1999
--- bash1147/lib/readline/vi_mode.c	Wed Mar 10 09:45:20 1999
***************
*** 349,355 ****
--- 349,359 ----
  }
  
  /* Move forward a word the way that 'W' does. */
+ #ifdef VMS
+ rl_vi_fwword (count)
+ #else
  rl_vi_fWord (count)
+ #endif
       int count;
  {
    while (count-- && rl_point < (rl_end - 1))
***************
*** 365,371 ****
--- 369,379 ----
    return (0);
  }
  
+ #ifdef VMS
+ rl_vi_bwword (count)
+ #else
  rl_vi_bWord (count)
+ #endif
       int count;
  {
    while (count-- && rl_point > 0)
***************
*** 388,394 ****
--- 396,406 ----
    return (0);
  }
  
+ #ifdef VMS
+ rl_vi_ewword (count)
+ #else
  rl_vi_eWord (count)
+ #endif
       int count;
  {
    while (count-- && rl_point < (rl_end - 1))
diff -r -c bash-1_14_7/machines.h bash1147/machines.h
*** bash-1_14_7/machines.h	Wed Mar 10 09:43:47 1999
--- bash1147/machines.h	Wed Mar 10 09:44:55 1999
***************
*** 586,591 ****
--- 586,623 ----
  
  #if defined (i386)
  
+ /* MS-DOS(DJGPP) */
+ #  if !defined (done386) && defined (__DJGPP__)
+ #    define done386
+ #    define M_MACHINE "PCAT"
+ #    define M_OS "MSDOS"
+ #    define USE_DOS
+ #    define REQUIRED_LIBRARIES
+ #    undef HAVE_SYS_SIGLIST
+ #    undef USE_GNU_MALLOC
+ #    define USE_GNU_TERMCAP
+ #  define HAVE_SETLINEBUF
+ #    define HAVE_VFPRINTF
+ /*#  define HAVE_GETGROUPS*/
+ #    define SYSDEP_CFLAGS -DUSE_DOS -DHAVE_BCOPY -DHAVE_UID_T -DHAVE_GETDTABLESIZE \
+ 			  -DHAVE_GETHOSTNAME
+ #    define HAVE_STRERROR
+ #    define HAVE_STRCASECMP
+ #    define HAVE_DIRENT
+ #    define VOID_SIGHANDLER
+ /* following comes from sysdefs.h */
+ #    define HAVE_WAIT_H
+ #    define HAVE_RESOURCE
+ #    define HAVE_SYS_PARAM
+ #    define HAVE_UNISTD_H
+ #    define HAVE_STDLIB_H
+ #    define HAVE_LIMITS_H
+ #    define HAVE_DIRENT_H
+ #    define HAVE_STRING_H
+ #    define HAVE_VARARGS_H
+ #    define HAVE_BISON
+ #  endif
+ 
  /* Sequent Symmetry running Dynix/ptx 2.x */
  #  if !defined (done386) && defined (_SEQUENT_)
  #    define done386
***************
*** 2229,2234 ****
--- 2261,2283 ----
  #  undef HAVE_ALLOCA
  #  undef HAVE_WAIT_H
  #endif /* cadmus */
+ 
+ /* X68000 */
+ #if defined (HUMAN68K)
+ #  define M_MACHINE "x68000"
+ #  define M_OS "Human68k"
+ #  define REQUIRED_LIBRARIES
+ #  define HAVE_SYS_SIGLIST
+ #  undef USE_GNU_MALLOC
+ #  define USE_GNU_TERMCAP
+ #  define HAVE_VFPRINTF
+ #  define SYSDEP_CFLAGS -DUSE_DOS -DHAVE_BCOPY -DHAVE_RESOURCE -DHAVE_UID_T \
+ 		-D__NO_SIGNAL_INLINE__
+ #  define HAVE_STRERROR
+ #  define HAVE_STRCASECMP
+ #  define HAVE_DIRENT
+ #  define VOID_SIGHANDLER
+ #endif
  
  /* **************************************************************** */
  /*								    */
diff -r -c bash-1_14_7/mailcheck.c bash1147/mailcheck.c
*** bash-1_14_7/mailcheck.c	Wed Mar 10 09:43:47 1999
--- bash1147/mailcheck.c	Fri Mar 19 17:36:15 1999
***************
*** 21,32 ****
--- 21,38 ----
  #include <stdio.h>
  #include "bashtypes.h"
  #include "posixstat.h"
+ #if !defined (VMS)
  #include <sys/param.h>
+ #endif
  #include "bashansi.h"
  #include "shell.h"
  #include "maxpath.h"
  #include "execute_cmd.h"
  #include <tilde/tilde.h>
+ 
+ #if defined (USE_VMS)
+ extern char *extract_unit (char *string, int *p_index, int separator);
+ #endif
  
  #ifndef NOW
  #define NOW ((time_t)time ((time_t *)0))
diff -r -c bash-1_14_7/make_cmd.c bash1147/make_cmd.c
*** bash-1_14_7/make_cmd.c	Wed Mar 10 09:43:47 1999
--- bash1147/make_cmd.c	Fri Mar 19 17:36:15 1999
***************
*** 50,55 ****
--- 50,58 ----
    temp = (WORD_DESC *)xmalloc (sizeof (WORD_DESC));
    temp->word = savestring (string);
    temp->quoted = temp->dollar_present = temp->assignment = 0;
+ #if defined (USE_VMS)
+   temp->expansion = 0;
+ #endif
  
    while (*string)
      {
***************
*** 423,430 ****
--- 426,438 ----
  	      len = strlen (line);
  	      if (len + document_index >= document_size)
  		{
+ #if 0
  		  document_size = document_size ? 2 * (document_size + len)
  						: 1000;	/* XXX */
+ #else
+ 		  document_size = document_size ? 2 * (document_size + len)
+ 						: len + document_index + 1;
+ #endif
  		  document = xrealloc (document, document_size);
  		}
  
diff -r -c bash-1_14_7/makefile. bash1147/makefile.
*** bash-1_14_7/makefile.	Wed Mar 10 09:43:47 1999
--- bash1147/makefile.	Wed Mar 10 09:44:55 1999
***************
*** 19,26 ****
  # MAKE    = make
  RM      = rm -f
  SHELL   = /bin/sh
! GAWK     = awk
! # GAWK     = gawk
  
  # Force CPPNAME to be the name of your C preprocesor if Bash can't
  # find it.  For instance, `CPPNAME=/usr/libexec/cpp' on 4.4 BSD.
--- 19,26 ----
  # MAKE    = make
  RM      = rm -f
  SHELL   = /bin/sh
! # GAWK     = awk
! GAWK     = gawk
  
  # Force CPPNAME to be the name of your C preprocesor if Bash can't
  # find it.  For instance, `CPPNAME=/usr/libexec/cpp' on 4.4 BSD.
***************
*** 74,80 ****
  	@test -s bash-Makefile || { rm -f bash-Makefile ; exit 1; }
  
  sysdefs.h: $(MKSYSDEFS)
! 	$(SHELL) $(MKSYSDEFS) -s $(srcdir)
  
  # This is also performed by support/mksysdefs, but there's no way to change
  # it if cpp-Makefile is changed without changing anything else, since there
--- 74,80 ----
  	@test -s bash-Makefile || { rm -f bash-Makefile ; exit 1; }
  
  sysdefs.h: $(MKSYSDEFS)
! 	$(SHELL) $(MKSYSDEFS) -s $(srcdir) -i $(DJDIR)/include
  
  # This is also performed by support/mksysdefs, but there's no way to change
  # it if cpp-Makefile is changed without changing anything else, since there
diff -r -c bash-1_14_7/news. bash1147/news.
*** bash-1_14_7/news.	Wed Mar 10 09:43:48 1999
--- bash1147/news.	Wed Mar 10 09:44:56 1999
***************
*** 1,10 ****
! This file documents the bugs fixed between this release, bash-1.14.7,
! and the last public bash release, 1.14.6.
  
  1.  Bugs fixed in Bash
  
! a.  A memory leak that caused long-running scripts to eventually consume
!     all available memory was fixed.
  
! b.  A sign-extension bug that caused a security hole for non-interactive
!     shells was fixed.
--- 1,55 ----
! This file documents the bugs fixed between this release, bash-1.14.6,
! and the last public bash release, 1.14.5.
  
  1.  Bugs fixed in Bash
  
! a.  Fix to the `fc' builtin to prevent core dumps when the history list
!     is empty.
  
! b.  Fix to `getopts' to keep it from running off the end of the array of
!     positional parameters.
! 
! c.  FIFOs are now created with mode 600 for security reasons.
! 
! d.  The list of active file descriptors connected to files in /dev/fd is
!     now properly zeroed when allocated or extended.
! 
! e.  Fix to trap so that the exit status is preserved around the command
!     executed via `trap 0', unless that command contains a call to exit.
!     If a call to exit appears, that will set the exit value for the shell.
! 
! f.  Fixed an off-by-one error that caused words to be split incorrectly
!     when IFS was set to "'".
! 
! g.  Fixed an off-by-one error that caused completion to sometimes fail
!     when escaped single quotes appeared in the command line.
! 
! h.  Fixed a parser error that occasionally resulted in close braces (`}')
!     causing syntax errors.
! 
! i.  There is now a machine description for HPUX version 10.x.
! 
! j.  Fixed an obscure bug that caused machines without restartable syscalls
!     to drop backslash-escaped characters when reading here documents in an
!     interactive shell.
! 
! k.  Fixed a bug that caused FIGNORE to occasionally allow some completions
!     that should be ignored.
! 
! l.  New machine descriptions: NetBSD/pmax, Linux/m68k, BSD/OS/sparc.
! 
! m.  Fixed a bug that caused the `vi' mode `v' command to execute the
!     original command after it was changed in the editor.
! 
! n.  Fixed some substitution bugs that left occasional stray CTLNUL characters
!     in the results of variable expansion.
! 
! o.  Updated machine descriptions: SCOv5.
! 
! 2.  Bugs fixed in Readline
! 
! a.  Fix to the history searching functions so a null search string does
!     not cause readline to seg fault.
! 
! b.  Fixed a bug in the completion code which caused words appearing on a
!     line after a quoted string to not be completed correctly.
diff -r -c bash-1_14_7/nojobs.c bash1147/nojobs.c
*** bash-1_14_7/nojobs.c	Wed Mar 10 09:43:48 1999
--- bash1147/nojobs.c	Fri Mar 19 17:36:15 1999
***************
*** 26,31 ****
--- 26,35 ----
  #include <setjmp.h>
  #include <errno.h>
  
+ #ifdef VMS
+ #include <wait.h>
+ #endif
+ 
  #include "config.h"
  #include "command.h"
  #include "general.h"
***************
*** 38,44 ****
  #  include "input.h"
  #endif
  
! #if !defined (USG) && !defined (_POSIX_VERSION)
  #  include <sgtty.h>
  #else
  #  if defined (_POSIX_VERSION)
--- 42,50 ----
  #  include "input.h"
  #endif
  
! #if defined (USE_VMS)
! #  include "vmstermios.h"
! #elif !defined (USG) && !defined (_POSIX_VERSION)
  #  include <sgtty.h>
  #else
  #  if defined (_POSIX_VERSION)
***************
*** 59,65 ****
  #  define killpg(pg, sig)		kill(-(pg),(sig))
  #endif /* USG || _POSIX_VERSION */
  
! #if defined (USG)
  #  define siginterrupt(sig, code)
  #endif /* USG */
  
--- 65,71 ----
  #  define killpg(pg, sig)		kill(-(pg),(sig))
  #endif /* USG || _POSIX_VERSION */
  
! #if defined (USG) || defined (USE_VMS)
  #  define siginterrupt(sig, code)
  #endif /* USG */
  
***************
*** 302,308 ****
--- 308,318 ----
    retry_fork:
  #endif /* _POSIX_VERSION */
  
+ #if defined (USE_VMS)
+   if ((pid = vmsutil_make_child_pid ()) < 0)
+ #else
    if ((pid = fork ()) < 0)
+ #endif
      {
  #if defined (_POSIX_VERSION)
        /* Posix systems with a non-blocking waitpid () system call available
***************
*** 319,325 ****
  
        throw_to_top_level ();
      }
!  
    if (pid == 0)
      {
  #if defined (BUFFERED_INPUT)
--- 329,335 ----
  
        throw_to_top_level ();
      }
! 
    if (pid == 0)
      {
  #if defined (BUFFERED_INPUT)
***************
*** 362,367 ****
--- 372,380 ----
  	last_asynchronous_pid = pid;
  
        add_pid (pid);
+ #if defined (USE_VMS)
+       vmsutil_current_pid = pid;
+ #endif
      }
    return (pid);
  }
***************
*** 477,482 ****
--- 490,506 ----
    if (!interactive_shell)
      old_sigint_handler = set_signal_handler (SIGINT, wait_sigint_handler);
  
+ #if defined (USE_VMS)
+   {
+     status = vmsutil_wait_status;
+     if ((status & 0x0000ff00) == 0x0000ff00)
+       status &= 0x000000ff;
+     errno = 0;
+     got_pid = pid;
+ 
+     last_made_pid = NO_PID;
+   }
+ #else
    while ((got_pid = WAITPID (-1, &status, 0)) != pid) /* XXX was pid now -1 */
      {
        if (got_pid < 0 && errno == ECHILD)
***************
*** 493,498 ****
--- 517,523 ----
        else if (got_pid > 0)
  	set_pid_status (got_pid, status);
      }
+ #endif /* !USE_VMS */
  
    set_pid_status (got_pid, status);
  
diff -r -c bash-1_14_7/parse.y bash1147/parse.y
*** bash-1_14_7/parse.y	Wed Mar 10 09:43:48 1999
--- bash1147/parse.y	Fri Mar 19 17:48:13 1999
***************
*** 27,32 ****
--- 27,36 ----
  #include "flags.h"
  #include "input.h"
  
+ #if defined (USE_VMS)
+ #include "vmsutil.h"
+ #endif
+ 
  #if defined (READLINE)
  #  include <readline/readline.h>
  #endif /* READLINE */
***************
*** 2406,2411 ****
--- 2410,2418 ----
      the_word->dollar_present = dollar_present;
      the_word->quoted = quoted;
      the_word->assignment = assignment (token);
+ #if defined (USE_VMS)
+     the_word->expansion = 0;
+ #endif
  
      yylval.word = the_word;
      result = WORD;
***************
*** 2614,2619 ****
--- 2621,2627 ----
  
    while (c = *string++)
      {
+ 
        if (posixly_correct && c == '!')
  	{
  	  if (*string == '!')
***************
*** 2723,2733 ****
--- 2731,2749 ----
  		temp = get_string_value ("PWD");
  
  		if (!temp)
+ #if defined (USE_VMS)
+ 		  vmsutil_getwd (t_string);
+ #else
  		  getwd (t_string);
+ #endif
  		else
  		  strcpy (t_string, temp);
  #else
+ #if defined (USE_VMS)
+ 		vmsutil_getwd (t_string);
+ #else
  		getwd (t_string);
+ #endif
  #endif	/* EFFICIENT */
  
  		if (c == 'W')
diff -r -c bash-1_14_7/print_cmd.c bash1147/print_cmd.c
*** bash-1_14_7/print_cmd.c	Wed Mar 10 09:43:48 1999
--- bash1147/print_cmd.c	Fri Mar 19 17:36:15 1999
***************
*** 30,36 ****
--- 30,40 ----
  #endif /* !HAVE_STRING_H */
  
  #include "shell.h"
+ #if defined (VMS)
+ #include "y_tab.h"
+ #else
  #include "y.tab.h"
+ #endif
  #include "stdc.h"
  #include "builtins/common.h"
  
diff -r -c bash-1_14_7/shell.c bash1147/shell.c
*** bash-1_14_7/shell.c	Wed Mar 10 09:43:48 1999
--- bash1147/shell.c	Fri Mar 19 17:47:48 1999
***************
*** 63,68 ****
--- 63,73 ----
  
  #include <tilde/tilde.h>
  
+ #if defined (USE_VMS)
+ #include "vmsutil.h"
+ #include <locale.h>
+ #endif
+ 
  #if defined (USG) && !defined (HAVE_GETPW_DECLS)
  extern struct passwd *getpwuid ();
  #endif /* USG && !HAVE_GETPW_DECLS */
***************
*** 174,180 ****
--- 179,189 ----
  time_t shell_start_time;
  
  /* The name of the .(shell)rc file. */
+ #if defined (VMS)
+ static char *bashrc_file = "sys$login:.bashrc";
+ #else
  static char *bashrc_file = "~/.bashrc";
+ #endif
  
  /* Non-zero means to act more like the Bourne shell on startup. */
  static int act_like_sh = 0;
***************
*** 248,253 ****
--- 257,271 ----
    int top_level_arg_index, read_from_stdin;
    FILE *default_input;
  
+ #if defined (USE_VMS)
+   setlocale (LC_CTYPE, "");
+   vmsutil_import_envvar ();
+   argv [0] = savestring (TO_CANONICAL_FILE_SPEC (argv[0]));
+   vmsutil_delsysroot (argv[0]);
+   vmsutil_reserve_fds ();
+   vmsutil_save_cwd ();
+ #endif /* !USE_VMS */
+ 
    /* There is a bug in the NeXT 2.1 rlogind that causes opens
       of /dev/tty to fail. */
  #if defined (RLOGIN_PGRP_BUG)
***************
*** 507,512 ****
--- 525,531 ----
  #endif /* JOB_CONTROL */
      }
  
+ #if !defined (USE_VMS)
  #define CLOSE_FDS_AT_LOGIN
  #if defined (CLOSE_FDS_AT_LOGIN)
    /*
***************
*** 522,527 ****
--- 541,547 ----
  	close (i);
      }
  #endif /* CLOSE_FDS_AT_LOGIN */
+ #endif /* USE_VMS */
  
    /* From here on in, the shell must be a normal functioning shell.
       Variables from the environment are expected to be set, etc. */
***************
*** 632,637 ****
--- 652,658 ----
      {
        int fd;
        char *filename;
+       struct stat statbuff;
  
        free (dollar_vars[0]);
        dollar_vars[0] = savestring (argv[arg_index]);
***************
*** 748,759 ****
    else if (!interactive)
      /* In this mode, bash is reading a script from stdin, which is a
         pipe or redirected file. */
  #if defined (BUFFERED_INPUT)
!     default_buffered_input = fileno (stdin);	/* == 0 */
  #else      
!     setbuf (default_input, (char *)NULL);
  #endif /* !BUFFERED_INPUT */
! 
    /* Bind remaining args to $1 ... $n */
    {
      WORD_LIST *args = (WORD_LIST *)NULL;
--- 769,784 ----
    else if (!interactive)
      /* In this mode, bash is reading a script from stdin, which is a
         pipe or redirected file. */
+     {
+ #if defined (USE_VMS)
+       fflush (stdin);
+ #endif
  #if defined (BUFFERED_INPUT)
!       default_buffered_input = fileno (stdin);	/* == 0 */
  #else      
!       setbuf (default_input, (char *)NULL);
  #endif /* !BUFFERED_INPUT */
!     }
    /* Bind remaining args to $1 ... $n */
    {
      WORD_LIST *args = (WORD_LIST *)NULL;
***************
*** 773,778 ****
--- 798,811 ----
    unset_nodelay_mode (fileno (stdin));
  #endif /* !BUFFERED_INPUT */
  
+ #if 0 /* def VMS Bug in DEC C RTL, fixed in VMS 7.2 */
+ #if defined (BUFFERED_INPUT)
+   lseek (default_buffered_input, 0, SEEK_SET);
+ #else
+   lseek (fileno (stdin), 0, SEEK_SET);
+ #endif
+ #endif
+ 
    /* with_input_from_stdin really means `with_input_from_readline' */
    if (interactive && !no_line_editing)
      with_input_from_stdin ();
***************
*** 845,856 ****
        if (login_shell && !no_profile)
          {
            if (act_like_sh)
              maybe_execute_file ("~/.profile", 1);
            else
              {
!               if (maybe_execute_file ("~/.bash_profile", 1) == 0)
  	        if (maybe_execute_file ("~/.bash_login", 1) == 0)
  	          maybe_execute_file ("~/.profile", 1);
              }
          }
  
--- 878,908 ----
        if (login_shell && !no_profile)
          {
            if (act_like_sh)
+ #if defined (USE_VMS)
+ 	    {
+ 	      if (maybe_execute_file ("sys$login:.profile", 1) == 0)
+ 		maybe_execute_file ("sys$login:_profile", 1);
+ 	    }
+ #else
              maybe_execute_file ("~/.profile", 1);
+ #endif
            else
              {
! #if defined (USE_VMS)
!               if (maybe_execute_file ("sys$login:.bash_profile", 1) == 0)
! 		if (maybe_execute_file ("sys$login:_bash_profile", 1) == 0)
! 		  if (maybe_execute_file ("sys$login:_bprof", 1) == 0)
! 		    if (maybe_execute_file ("sys$login:.bash_login", 1) == 0)
! 		      if (maybe_execute_file ("sys$login:_bash_login", 1) == 0)
! 			if (maybe_execute_file ("sys$login:_blogin", 1) == 0)
! 			  if (maybe_execute_file ("sys$login:.profile", 1)
! 			      == 0)
! 			    maybe_execute_file ("sys$login:_profile", 1);
! #else
! 	      if (maybe_execute_file ("~/.bash_profile", 1) == 0)
  	        if (maybe_execute_file ("~/.bash_login", 1) == 0)
  	          maybe_execute_file ("~/.profile", 1);
+ #endif
              }
          }
  
***************
*** 878,884 ****
--- 930,942 ----
        if (!act_like_sh && !no_rc &&
            (interactive_shell || (isnetconn (fileno (stdin)) &&
  			         local_pending_command)))
+ #if defined (USE_VMS)
+ 	if (maybe_execute_file (bashrc_file, 1) == 0
+ 	    && strcmp (bashrc_file, "sys$login:.bashrc") == 0)
+ 	  maybe_execute_file ("sys$login:_bashrc", 1);
+ #else
          maybe_execute_file (bashrc_file, 1);
+ #endif
      }
  
     /* Try a TMB suggestion.  If running a script, then execute the
***************
*** 948,959 ****
       int force_noninteractive;
  {
    jmp_buf old_return_catch;
!   int return_val, fd, tresult, old_interactive;
    char *filename, *string;
    struct stat file_info;
  
    filename = tilde_expand (fname);
    fd = open (filename, O_RDONLY);
  
    if (fd < 0)
      {
--- 1006,1023 ----
       int force_noninteractive;
  {
    jmp_buf old_return_catch;
!   int return_val, fd, tresult, old_interactive, tnext;
    char *filename, *string;
    struct stat file_info;
  
    filename = tilde_expand (fname);
+ #if defined (USE_VMS)
+   errno = 0;
+   filename = vmsutil_expand_path (filename);
+   fd = open (filename, O_RDONLY);
+ #else
    fd = open (filename, O_RDONLY);
+ #endif
  
    if (fd < 0)
      {
***************
*** 975,981 ****
      }
  
    string = (char *)xmalloc (1 + (int)file_info.st_size);
!   tresult = read (fd, string, file_info.st_size);
  
    {
      int tt = errno;
--- 1039,1051 ----
      }
  
    string = (char *)xmalloc (1 + (int)file_info.st_size);
!   tnext = 0;
!   do 
!     {
!       tresult = read (fd, &string [tnext], file_info.st_size);
!       tnext += tresult;
!     } while (tresult > 0);
!   tresult = tnext;
  
    {
      int tt = errno;
***************
*** 983,994 ****
--- 1053,1072 ----
      errno = tt;
    }
  
+ #if defined (USE_VMS)
+   if (tresult < 0)
+ #else
    if (tresult != file_info.st_size)
+ #endif
      {
        free (string);
        goto file_error_and_exit;
      }
+ #if defined (USE_VMS)
+   string[tresult] = '\0';
+ #else
    string[file_info.st_size] = '\0';
+ #endif
  
    return_catch_flag++;
    xbcopy ((char *)return_catch, (char *)old_return_catch, sizeof (jmp_buf));
***************
*** 1123,1128 ****
--- 1201,1209 ----
  		{
  		  executing = 1;
  		  execute_command (current_command);
+ #if defined (USE_VMS)
+ 		  vmsutil_pipe_clean (0);
+ #endif
  		}
  
  	    exec_done:
***************
*** 1310,1315 ****
--- 1391,1401 ----
  	else
  	  current_user.shell = savestring ("/bin/sh");
  	current_user.home_dir = savestring (entry->pw_dir);
+ #if defined (USE_VMS)
+ 	current_user.shell = savestring ("bash");
+ 	current_user.home_dir = savestring
+ 	  (to_canonical_dir_spec (current_user.home_dir, 0));
+ #endif
        }
      else
        {
***************
*** 1318,1324 ****
--- 1404,1412 ----
  	current_user.home_dir = savestring ("/");
        }
  
+ #if !defined (VMS)
      endpwent ();
+ #endif
    }
  
    /* Initialize our interface to the tilde expander. */
***************
*** 1374,1380 ****
--- 1462,1472 ----
  
    /* Ensure that the default startup file is used.  (Except that we don't
       execute this file for reinitialized shells). */
+ #if defined (VMS)
+   bashrc_file = "sys$login:.bashrc";
+ #else
    bashrc_file = "~/.bashrc";
+ #endif
  
    /* Delete all variables and functions.  They will be reinitialized when
       the environment is parsed. */
***************
*** 1589,1594 ****
--- 1681,1687 ----
  
  #endif /* !_POSIX_VERSION */
  
+ #if !defined (USE_VMS)
  #if defined (JOB_CONTROL) || defined (_POSIX_VERSION)
    /* All shells use the signal mask they inherit, and pass it along
       to child processes.  Children will never block SIGCHLD, though. */
***************
*** 1596,1601 ****
--- 1689,1695 ----
    sigprocmask (SIG_BLOCK, (sigset_t *)NULL, &top_level_mask);
    sigdelset (&top_level_mask, SIGCHLD);
  #endif /* JOB_CONTROL || _POSIX_VERSION */
+ #endif /* USE_VMS */
  
    /* And, some signals that are specifically ignored by the shell. */
    set_signal_handler (SIGQUIT, SIG_IGN);
***************
*** 1714,1719 ****
--- 1808,1828 ----
    set_signal_handler (sig, sigint_sighandler);
  #endif
  
+ #if defined (USE_VMS) /* ??? */
+ #define SIG_TRAPPED     0x1	/* Currently trapped. */
+ #define SIG_INPROGRESS  0x10	/* Signal handler currently executing. */
+   {
+     extern int vmsutil_get_signal_modes (int);
+     extern int vmsutil_set_signal_modes (int, int);
+     int modes;
+ 
+     modes = vmsutil_get_signal_modes (SIGINT);
+     if (interrupt_state == 0 && interrupt_immediately == 0
+         && (modes & (SIG_INPROGRESS | SIG_TRAPPED)) == (SIG_INPROGRESS | SIG_TRAPPED))
+       vmsutil_set_signal_modes (SIGINT, modes & ~SIG_INPROGRESS);
+   }
+ #endif
+ 
    /* interrupt_state needs to be set for the stack of interrupts to work
       right.  Should it be set unconditionally? */
    if (!interrupt_state)
***************
*** 1743,1750 ****
--- 1852,1873 ----
  void
  show_shell_version ()
  {
+ #if defined (USE_VMS) /* ??? fix version numbers */
+   {
+     char *p = savestring (base_pathname (shell_name));
+ 
+     if (strlen (p) >= sizeof (".exe"))
+       if (stricmp (p + strlen (p) - (sizeof (".exe") - 1), ".exe") == 0)
+ 	p[strlen (p) - (sizeof (".exe") - 1)] = '\0';
+     printf ("GNU %s, version %s%s\n", p, shell_version_string (),
+ 	    vmsutil_version_string ());
+ 
+     free (p);
+   }
+ #else
    printf ("GNU %s, version %s\n", base_pathname (shell_name),
      shell_version_string ());
+ #endif
  }
  
  #if !defined (USG) && defined (ENOTSOCK)
***************
*** 1771,1776 ****
--- 1894,1902 ----
    return (S_ISCHR (sb.st_mode));
  #else /* !USGr4 && !USGr4_2 */
  #  if defined (HAVE_SOCKETS)
+ #if defined (VMS)
+   unsigned
+ #endif
    int rv, l;
    struct sockaddr sa;
  
